(function() {
  /*
  Copyright (c) 2002-2015 "Neo Technology,"
  Network Engine for Objects in Lund AB [http://neotechnology.com]
  
  This file is part of Neo4j.
  
  Neo4j is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; }, __hasProp = Object.prototype.hasOwnProperty, __extends = function(child, parent) {
    for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; }
    function ctor() { this.constructor = child; }
    ctor.prototype = parent.prototype;
    child.prototype = new ctor;
    child.__super__ = parent.prototype;
    return child;
  };
  define(['ribcage/Model'], function(Model) {
    var Queue;
    return Queue = (function() {
      __extends(Queue, Model);
      function Queue() {
        this.hasMoreItems = __bind(this.hasMoreItems, this);
        this.push = __bind(this.push, this);
        this.pull = __bind(this.pull, this);        this.queue = [];
      }
      Queue.prototype.pull = function() {
        var item;
        item = this.queue.shift();
        this.trigger("item:pulled", this, item);
        return item;
      };
      Queue.prototype.push = function(item) {
        this.queue.push(item);
        return this.trigger("item:pushed", this, item);
      };
      Queue.prototype.hasMoreItems = function() {
        return this.queue.length > 0;
      };
      return Queue;
    })();
  });
}).call(this);
